# This file is a template, and might need editing before it works on your project.
# Official language image. Look for the different tagged releases at:
# https://hub.docker.com/r/library/python/tags/
image: python:latest

stages:
  - test
  - run
  - pages
  - upload

# Change pip's cache directory to be inside the project directory since we can
# only cache local items.
variables:
  PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache/pip"

# Pip's cache doesn't store the python packages
# https://pip.pypa.io/en/stable/reference/pip_install/#caching
#
# If you want to also cache the installed packages, you have to install
# them in a virtualenv and cache it as well.
cache:
  paths:
    - .cache/pip
    - .venv/

before_script:
  - python -V  # Print out python version for debugging
  - pip install virtualenv
  - virtualenv .venv
  - source .venv/bin/activate

test:
  stage: test
  script:
    - python setup.py test
    - pip install tox flake8 pytest # you can also use tox
    - tox

run:
  stage: run
  script:
    - python setup.py bdist_wheel
    # an alternative approach is to install and run:
    - pip install dist/*
    # run the command here
  artifacts:
    paths:
      - dist/*.whl

pages:
  stage: pages
  script:
    - pip install sphinx sphinx-rtd-theme
    - cd doc ; make html
    - mv _build/html/ ../public/
  artifacts:
    paths:
      - public
  only:
    - main

upload:
  stage: upload
  script:
    - python setup.py sdist bdist_wheel
    - pip install twine
    - TWINE_PASSWORD=${CI_JOB_TOKEN} TWINE_USERNAME=gitlab-ci-token python -m twine upload --verbose --config-file .pypirc --repository gitlab dist/*
  only:
    - main
